'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.configureAliases = undefined;

var _path = require('path');

var _aliases = require('./aliases');

var _module = require('module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var settings = 0;

var configureAliases = function configureAliases(conf) {
  settings = (0, _aliases.readAlises)(conf);
};

var relativeName = function relativeName(a, b) {
  var name = (0, _path.relative)(a, b);
  if (name && name[0] != '/' && name[0] != '.') {
    return './' + name;
  }
  return name;
};

var aliasResolve = function aliasResolve(fileName, stubs, relativeModule) {
  if (!settings) {
    settings = (0, _aliases.readAlises)();
  }
  // nodejs internals
  var sourceFile = _module2.default._resolveFilename(fileName, relativeModule);
  var sourceDir = (0, _path.dirname)(sourceFile);

  var result = {};
  for (var i in stubs) {
    var resolvedFileName = (0, _aliases.processFile)(i, settings);
    if (resolvedFileName) {
      result[relativeName(sourceDir, resolvedFileName)] = stubs[i];
    } else {
      result[i] = stubs[i];
    }
  }
  return result;
};

exports.configureAliases = configureAliases;
exports.default = aliasResolve;