'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.configure = undefined;

var _aliases = require('./common/aliases');

var _common = require('./_common');

var _common2 = _interopRequireDefault(_common);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var settings = null;

var configure = function configure(fileName) {
    settings = (0, _aliases.readAlises)(fileName);
};

var fileNameTransformer = function fileNameTransformer(fileName) {
    if (!settings) {
        configure();
    }
    return (0, _aliases.processFile)(fileName, settings);
};

var wipeCheck = function wipeCheck(stubs, moduleName) {
    return (0, _common.standardWipeCheck)(stubs, moduleName);
};

exports.configure = configure;
exports.default = (0, _common2.default)({
    fileNameTransformer: fileNameTransformer,
    wipeCheck: wipeCheck
});