'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _wipeNodeCache = require('wipe-node-cache');

var _wipeNodeCache2 = _interopRequireDefault(_wipeNodeCache);

var _mocks = require('./mocks');

var _plugins = require('./plugins');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var primaryResolver = function primaryResolver(stubs, moduleName) {
    return stubs[moduleName];
};

var resolver = function resolver(stubs, moduleName) {
    // never wipe .node(native) module
    if (moduleName.indexOf('\.node') > -1) {
        return false;
    }
    return (0, _plugins.shouldWipe)(stubs, moduleName);
};

var wipeCache = function wipeCache() {
    var primaryCache = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    (0, _wipeNodeCache2.default)(primaryCache, primaryResolver);
    (0, _wipeNodeCache2.default)((0, _mocks.getAllMocks)(), resolver);
};

exports.default = wipeCache;